#!/usr/bin/awk -F/
#
# Copyright (c) 2008 Diomidis Spinellis
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. Publications using results from this work or its derivatives must
#    acknowledge the work's origin by citing the corresponding August 2008
#    Communications of the ACM paper.
#
# THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: color.awk,v 1.1 2008/06/26 06:30:41 dds Exp $
#
# Post-process a suitably commented neato diagram to add color
# Move across (50, 0, 128)-(255, 50, 128)-(0, 255, 128)-(
#

BEGIN {max = 17050358 }
NF == 3 {
	if ($3 < max / 2) {
		# 50 - 255
		r = $3 / max * 2 * (255 - 50) + 50
		# 0 - 50
		g = $3 / max * 2 * 50
	} else {
		# 255 - 0
		r = 255 - ($3 - max / 2) / max * 2 * 255
		# 50 - 255
		g = ($3 - max / 2) / max * 2 * (255 - 50) + 50
	}
	#r = sprintf("%02x", r);
	#g = sprintf("%02x", g);
	# print substr($1, 0, length($1) - 2) " [fontcolor=\"#" r  g "80\"];"
	#print substr($1, 0, length($1) - 2) " [fontcolor=\"" r ", " g ", 128\"];"
	print substr($1, 0, length($1) - 2) " [fontcolor=\"" $3 / max ", " 1 ", 1\"];"
}
NF != 3 { print }
