# Copyright (c) 2007, 2008 Diomidis Spinellis and Panagiotis Louridas
#
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. Publications using results from this work or its derivatives must
#    acknowledge the work's origin by citing the corresponding August 2008
#    Communications of the ACM paper.
#
# THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: fitfreqs.pl,v 1.1 2008/06/26 09:42:56 panos Exp $

use strict;

print <<END;
set xlabel "References added to article in a month"
set ylabel "Number of articles"
set logscale x
set logscale y
set yrange[1:]
END

my @values;
while (<>)
{
	my ($a, $b, @rest) = split;
	push(@values, (split(/=/, $a))[1]);
	push(@values, (split(/=/, $b))[1]);
}

my $plot = 'plot "makedist.data" index 0 using 1:2 title "expected" with points pointtype 7, "makedist.data" index 1 using 1:2 title "actual" with points pointtype 7, %s * x**(%s) title "expected fit", %s * x**(%s) title "actual fit"';

$plot = sprintf($plot, @values);

print $plot;

print "\nset output 'nul'\n";

